<?php
class ControllerExtensionPaymentBerekeBank extends Controller
{
/**
* @param $registry
*/
public function __construct($registry)
{
parent::__construct($registry);
$this->load->language('extension/payment/berekebank');
if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/extension/payment/berekebank.tpl')) {
$this->have_template = true;
}
}
/**
* @return mixed
*/
public function index()
{
$data['action'] = $this->url->link('extension/payment/berekebank/payment','',true);
$data['berekebank_button_confirm'] = $this->language->get('berekebank_button_confirm');
return $this->get_template('extension/payment/berekebank', $data);
}
/**
* @param $template
* @param $data
* @return mixed
*/
private function get_template($template, $data)
{
return $this->load->view($template, $data);
}
public function payment()
{
$this->initializeGatewayLibrary();
$this->load->model('checkout/order');
$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
$order_number = (int)$order_info['order_id'];
$amount = round($order_info['total'] * $order_info['currency_value'], 2) * 100;
$return_url = $this->url->link('extension/payment/berekebank/comeback');
$jsonParams = array(
'CMS' => 'Opencart ' . VERSION,
'Module-Version' => 'BerekeBank ' . $this->method_library->version,
);
if (!empty($order_info['email'])) {
$jsonParams['email'] = $order_info['email'];
}
if (!empty($order_info['telephone'])) {
}
if ( $this->method_library->enable_back_url_settings
&& !empty($this->config->get('berekebank_backToShopURL'))
) {
$jsonParams['backToShopUrl'] = $this->config->get('berekebank_backToShopURL');
}
$orderBundle = [];
$orderBundle['customerDetails'] = array(
'email' => $order_info['email'],
);
foreach ($this->cart->getProducts() as $product) {
$product_taxSum = $this->tax->getTax($product['price'], $product['tax_class_id']);
$product_amount = ($product['price'] + $product_taxSum) * $product['quantity'];
$tax_type = $this->config->get('berekebank_taxType');
if ($product['tax_class_id'] != 0) {
$item_rate = $product_taxSum / $product['price'] * 100;
switch ($item_rate) {
case 20:
$tax_type = 6;
break;
case 18:
$tax_type = 3;
break;
case 10:
$tax_type = 2;
break;
case 0:
$tax_type = 1;
break;
default:
$tax_type = $this->config->get('berekebank_taxType');
}
}
$product_data = array(
'positionId' => $product['cart_id'],
'name' => $product['name'],
'quantity' => array(
'value' => $product['quantity'],
'measure' => (!empty($item['arrGate']['quantity']['measure'])) ? $item['arrGate']['quantity']['measure'] : $this->method_library->getDefaultMeasurement(),
),
'itemAmount' => $product_amount * 100,
'itemCode' => $product['product_id'] . "_" . $product['cart_id'], //fix by PLUG-1740, PLUG-2620
'tax' => array(
'taxType' => $tax_type,
'taxSum' => $product_taxSum * 100
),
'itemPrice' => ($product['price'] + $product_taxSum) * 100,
);
$attributes = array();
$attributes[] = array(
"name" => "paymentMethod",
"value" => $this->method_library->getPaymentMethodType()
);
$attributes[] = array(
"name" => "paymentObject",
"value" => $this->method_library->getPaymentObjectType()
);
$product_data['itemAttributes']['attributes'] = $attributes;
$orderBundle['cartItems']['items'][] = $product_data;
}
if (isset($this->session->data['shipping_method']['cost']) && $this->session->data['shipping_method']['cost'] > 0) {
$delivery['positionId'] = 'delivery';
$delivery['name'] = $this->session->data['shipping_method']['title'];
$delivery['itemAmount'] = $this->session->data['shipping_method']['cost'] * 100;
$delivery['quantity']['value'] = 1;
$delivery['quantity']['measure'] = $this->method_library->getDefaultMeasurement();
$delivery['itemCode'] = $this->session->data['shipping_method']['code'];
$delivery['tax']['taxType'] = $this->config->get('berekebank_taxType');
$delivery['tax']['taxSum'] = 0;
$delivery['itemPrice'] = $this->session->data['shipping_method']['cost'] * 100;
$attributes = array();
$attributes[] = array(
"name" => "paymentMethod",
"value" => $this->method_library->getPaymentMethodType(true)
);
$attributes[] = array(
"name" => "paymentObject",
"value" => 4
);
$delivery['itemAttributes']['attributes'] = $attributes;
$orderBundle['cartItems']['items'][] = $delivery;
}
if(isset($this->session->data['vouchers']) && count($this->session->data['vouchers']) > 0) {
foreach ($this->session->data['vouchers'] as $key => $voucher) {
$itemVoucher = array(
'positionId' => $key,
'name' => $voucher['description'],
'itemAmount' => $voucher['amount'] * 100,
'quantity' => array(
'value' => 1,
'measure' => $this->method_library->getDefaultMeasurement(),
),
'itemCode' => 'voucher_' . $key,
'tax' => array(
'taxType' => $this->config->get('berekebank_taxType'),
'taxSum' => 0,
),
'itemPrice' => $voucher['amount'] * 100
);
$attributes = array();
$attributes[] = array(
"name" => "paymentMethod",
"value" => $this->method_library->getPaymentMethodType(),
);
$attributes[] = array(
"name" => "paymentObject",
"value" => 1
);
$itemVoucher['itemAttributes']['attributes'] = $attributes;
$orderBundle['cartItems']['items'][] = $itemVoucher;
}
}
if ($this->method_library->berekebank_enable_cart_options && $this->method_library->send_cart) {
$discount = $this->method_library->discountHelper->discoverDiscount($amount, $orderBundle['cartItems']['items']);
if ($discount > 0) {
$this->method_library->discountHelper->setOrderDiscount($discount);
$recalculatedPositions = $this->method_library->discountHelper->normalizeItems($orderBundle['cartItems']['items']);
$recalculatedAmount = $this->method_library->discountHelper->getResultAmount();
$orderBundle['cartItems']['items'] = $recalculatedPositions;
}
}
$args = array(
'orderNumber' => $order_number . "_" . time(),
'amount' => $amount,
'returnUrl' => $return_url,
'jsonParams' => json_encode($jsonParams),
);
if (defined('RBSPAYMENT_MANDATORY_CURRENCY') && RBSPAYMENT_MANDATORY_CURRENCY === true) {
$currency_code = $this->method_library->get_numeric_currency_code($order_info['currency_code']);
if (!empty($currency_code)){
$args['currency'] = $currency_code;
}
}
if (!empty($order_info['customer_id'] && $order_info['customer_id'] > 0)) {
$client_email = !empty($order_info['email']) ? $order_info['email'] : "";
$args['clientId'] = md5($order_info['customer_id']  .  $client_email  . $order_info['store_url']);
}
if (defined('RBSPAYMENT_SEND_CLIENT_FULL_INFO') && RBSPAYMENT_SEND_CLIENT_FULL_INFO === true) {
$billingPayerData = $this->_getBillingPayerData($order_info);
if(!empty($billingPayerData)) {
$args['billingPayerData'] = json_encode($billingPayerData);
}
}
if ($this->method_library->berekebank_enable_cart_options && $this->method_library->send_cart && !empty($orderBundle)) {
$args['taxSystem'] = $this->method_library->taxSystem;
$args['orderBundle']['orderCreationDate'] = date('c');
$args['orderBundle'] = json_encode($orderBundle);
}
$response = $this->method_library->gateway($this->method_library->stage == 'two' ? 'registerPreAuth.do' : 'register.do', $args);
$response = json_decode($response,true);
if (isset($response['orderId'])) {
$comment = "Order created in payment gateway";
$this->model_checkout_order->addOrderHistory($order_number, $this->config->get('berekebank_order_status_before_id'), $comment, true);
}
if (isset($response['errorCode'])) {
$this->document->setTitle($this->language->get('error_title'));
$data['header'] = $this->load->controller('common/header');
$data['column_left'] = $this->load->controller('common/column_left');
$data['column_right'] = $this->load->controller('common/column_right');
$data['content_top'] = $this->load->controller('common/content_top');
$data['button_continue'] = $this->language->get('error_continue');
$data['heading_title'] = $this->language->get('error_title') . ' #' . $response['errorCode'];
$data['text_error'] = $response['errorMessage'];
$data['continue'] = $this->url->link('checkout/cart');
$data['content_bottom'] = $this->load->controller('common/content_bottom');
$data['footer'] = $this->load->controller('common/footer');
$this->response->setOutput($this->get_template('error/berekebank', $data));
} else {
$this->response->redirect($response['formUrl']);
}
}
private function initializeGatewayLibrary()
{
$this->library('BerekeBank');
$this->method_library = new BerekeBank();
$this->method_library->token = $this->config->get('berekebank_merchantToken');
$this->method_library->login = $this->config->get('berekebank_merchantLogin');
$this->method_library->password = $this->config->get('berekebank_merchantPassword');
$this->method_library->stage = $this->config->get('berekebank_stage');
$this->method_library->mode = $this->config->get('berekebank_mode');
$this->method_library->berekebank_cacert_enable = $this->config->get('berekebank_berekebank_cacert_enable');
$this->method_library->berekebank_cacert_path = null;
$this->method_library->logging = $this->config->get('berekebank_logging');
$this->method_library->taxSystem = $this->config->get('berekebank_taxSystem');
$this->method_library->taxType = $this->config->get('berekebank_taxType');
$this->method_library->send_cart = $this->config->get('berekebank_send_cart');
$this->method_library->versionFfd = $this->config->get('berekebank_version_ffd');
$this->method_library->paymentMethodType = $this->config->get('berekebank_paymentMethodType');
$this->method_library->paymentMethodTypeDelivery = $this->config->get('berekebank_paymentMethodTypeDelivery');
$this->method_library->paymentObjectType = $this->config->get('berekebank_paymentObjectType');
$this->method_library->backToShopURL = $this->config->get('berekebank_backToShopURL');
$this->method_library->language = substr($this->language->get('code'), 0, 2);
}
private function library($library)
{
$file = DIR_SYSTEM . 'library/' . str_replace('../', '', (string)$library) . '.php';
if (file_exists($file)) {
include_once($file);
} else {
trigger_error('Error: Could not load library ' . $file . '!');
exit();
}
}
public function callback()
{
if (isset($this->request->get['mdOrder'])) {
$order_id = $this->request->get['mdOrder'];
} else {
die('Illegal Access');
}
$this->initializeGatewayLibrary();
if (!$this->method_library->allowCallbacks) {
exit;
}
$response = $this->method_library->get_order_status($order_id);
$response = json_decode($response, true);
$ex = explode("_", $response['orderNumber']);
$order_number = $ex[0];
$this->load->model('checkout/order');
$order_info = $this->model_checkout_order->getOrder($order_number);
if ($order_info) {
if (($response['errorCode'] == 0) && (($response['orderStatus'] == 1) || ($response['orderStatus'] == 2))) {
$this->_storeGatewayOrderData($order_id, $order_info, $response);
$comment = "Incoming callback";
$this->model_checkout_order->addOrderHistory($order_number, $this->config->get('berekebank_order_status_completed_id'), $comment, false);
} else {
}
}
}
public function comeback()
{
if (isset($this->request->get['orderId'])) {
$order_id = $this->request->get['orderId'];
} else {
die('Illegal Access');
}
$this->initializeGatewayLibrary();
$response = $this->method_library->get_order_status($order_id);
$response = json_decode($response, true);
$ex = explode("_", $response['orderNumber']);
$order_number = $ex[0];
$this->load->model('checkout/order');
$order_info = $this->model_checkout_order->getOrder($order_number);
if ($order_info) {
if (($response['errorCode'] == 0) && (($response['orderStatus'] == 1) || ($response['orderStatus'] == 2))) {
if (!$this->method_library->allowCallbacks) {
$this->_storeGatewayOrderData($order_id, $order_info, $response);
$comment = "Incoming ReturnUrl";
$this->model_checkout_order->addOrderHistory($order_number, $this->config->get('berekebank_order_status_completed_id'), $comment, false);
}
$this->response->redirect($this->url->link('checkout/success', '', true));
} else {
$this->response->redirect($this->url->link('checkout/failure', '', true));
}
}
}
public function _storeGatewayOrderData($order_id, $order_info, $response) {
$this->load->model('extension/payment/berekebank');
$data = array(
'order_id' => (int)$order_info['order_id'],
'gateway_order_reference' => $order_id,
'currency' => $response['currency'],
'order_amount' => $response['amount'],
'order_amount_deposited' => $response['amount'],
'status_deposited' => $response['orderStatus'] === 1 ? 0 : 1, //todo
);
$this->model_extension_payment_berekebank->storeGatewayOrder($data);
}
private function _getBillingPayerData($orderData) {
$billingPayerData = array(
'billingCity' => '',
'billingCountry' => '',
'billingAddressLine1' => '',
'billingAddressLine2' => '',
'billingAddressLine3' => '',
'billingPostalCode' => '',
'billingState' => ''
);
if (isset($orderData['payment_address_id']) && $orderData['payment_address_id'] != 0) {
$billingPayerData['billingCity'] = $orderData['payment_city'];
$billingPayerData['billingCountry'] = $orderData['payment_iso_code_2'];//$orderData['payment_country'];
$billingPayerData['billingAddressLine1'] = $orderData['payment_address_1'];
$billingPayerData['billingAddressLine2'] = $orderData['payment_address_2'];
$billingPayerData['billingPostalCode'] = $orderData['payment_postcode'];
$billingPayerData['billingState'] = $orderData['payment_zone'];
} else {
$billingPayerData['billingCity'] = $orderData['shipping_city'];
$billingPayerData['billingCountry'] = $orderData['shipping_iso_code_2'];//$orderData['shipping_country'];
$billingPayerData['billingAddressLine1'] = $orderData['shipping_address_1'];
$billingPayerData['billingAddressLine2'] = $orderData['shipping_address_2'];
$billingPayerData['billingPostalCode'] = $orderData['shipping_postcode'];
$billingPayerData['billingState'] = $orderData['shipping_zone'];
}
return $billingPayerData;
}
}